diff --git a/src/7z_fmt_plug.c b/src/7z_fmt_plug.c
index feab12cb8c..f1203b397f 100644
--- a/src/7z_fmt_plug.c
+++ b/src/7z_fmt_plug.c
@@ -30,6 +30,12 @@ john_register_one(&fmt_sevenzip);
 #endif
 
 #include "arch.h"
+
+#if !ARCH_LITTLE_ENDIAN
+#undef SIMD_COEF_32
+#undef SIMD_PARA_SHA256
+#endif
+
 #include "johnswap.h"
 #include "misc.h"
 #include "common.h"
